﻿using Syncfusion.UI.Xaml.Charts;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace VisibleRange
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        bool xCanCalculate, yCanCalculate;
        DoubleRange xActualRange, yActualRange;
        public MainWindow()
        {
            InitializeComponent();
        }

        
        private void SfChart_SelectionZoomingEnd(object sender, SelectionZoomingEndEventArgs e)
        {
            var chart = sender as SfChart;
            var xAxis = chart.PrimaryAxis as CategoryAxis;
            var xVisibleRange = CalculateRange(xAxis,xActualRange, xAxis.ZoomPosition, xAxis.ZoomFactor);
            var yAxis = chart.SecondaryAxis as NumericalAxis;
            var yVisibleRange = CalculateRange(yAxis,yActualRange, yAxis.ZoomPosition, yAxis.ZoomFactor);
        }

        internal DoubleRange CalculateRange(ChartAxisBase2D axis, DoubleRange actualRange, double zoomPosition, double zoomFactor)
        {
            DoubleRange baseRange = actualRange;
            double start = actualRange.Start + zoomPosition * actualRange.Delta;
        
            double end = start + zoomFactor * actualRange.Delta;

            if (start < baseRange.Start)
            {
                end = end + (baseRange.Start - start);
                start = baseRange.Start;
            }

            if (end > baseRange.End)
            {
                start = start - (end - baseRange.End);
                end = baseRange.End;
            }
            DoubleRange range = new DoubleRange(start, end);
            return range;
        }

        private void CategoryAxis_ActualRangeChanged(object sender, ActualRangeChangedEventArgs e)
        {  
                double start = Convert.ToDouble(e.ActualMinimum);
                double end = Convert.ToDouble(e.ActualMaximum);
                xActualRange = new DoubleRange(start , end);         
        }

        private void NumericalAxis_ActualRangeChanged(object sender, ActualRangeChangedEventArgs e)
        {        
                double start = Convert.ToDouble(e.ActualMinimum);
                double end = Convert.ToDouble(e.ActualMaximum);
                yActualRange = new DoubleRange(start, end);
                yCanCalculate = true;
        }
    }

    public class Commodities
    {
        public string Commodity { get; set; }
        public double ChangingPrice { get; set; }
    }

    public class CommoditiesPrices
    {
        public CommoditiesPrices()
        {
            CommodityDetails = new ObservableCollection<Commodities>();
            CommodityDetails.Add(new Commodities() { Commodity = "Gold", ChangingPrice = 46 });
            CommodityDetails.Add(new Commodities() { Commodity = "Silver", ChangingPrice = -10 });
            CommodityDetails.Add(new Commodities() { Commodity = "Crudeoil", ChangingPrice = -34 });
            CommodityDetails.Add(new Commodities() { Commodity = "Naturalgas", ChangingPrice = -45 });
            CommodityDetails.Add(new Commodities() { Commodity = "Aluminium", ChangingPrice = 8 });
            CommodityDetails.Add(new Commodities() { Commodity = "Copper", ChangingPrice = 23 });
            CommodityDetails.Add(new Commodities() { Commodity = "Nickel", ChangingPrice = -15 });
            CommodityDetails.Add(new Commodities() { Commodity = "Lead", ChangingPrice = 16 });
            CommodityDetails.Add(new Commodities() { Commodity = "Cotton", ChangingPrice = 37 });
            CommodityDetails.Add(new Commodities() { Commodity = "Menthaoil", ChangingPrice = -22 });
            CommodityDetails.Add(new Commodities() { Commodity = "Zinc", ChangingPrice = 13 });

        }

        public ObservableCollection<Commodities> CommodityDetails { get; set; }
    }
}
